<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/BoostBook.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/BoostBook.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/BoostBook.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;a BoostBook formatter&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor, Parameter</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> sys, getopt, os, os.path</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html">Formatter</a>(Processor, ASG.Visitor):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">   <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">   The type visitors should generate names relative to the current scope.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">   The generated references however are fully scoped names</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">   &quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">      self.__os = open(self.output, <span class="py-string">'w'</span>)</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">      self.__scope = ()</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">      self.__scopestack = []</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">      self.__indent = 0</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">      self.__type_label = <span class="py-string">''</span></span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> ir.asg.declarations:</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">         d.accept(self)</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">      self.__os.close()</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">      <span class="py-keyword">return</span> self.ir</span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#scope">scope</a>(self): <span class="py-keyword">return</span> self.__scope</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#push_scope">push_scope</a>(self, newscope):</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      self.__scopestack.append(self.__scope)</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">      self.__scope = newscope</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#pop_scope">pop_scope</a>(self):</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">      self.__scope = self.__scopestack[-1]</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">      <span class="py-keyword">del</span> self.__scopestack[-1]</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#write">write</a>(self, text):</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Write some text to the output stream, replacing \n's with \n's and</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="py-string">      indents.&quot;&quot;&quot;</span></span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">      indent = <span class="py-string">' '</span> * self.__indent</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">      self.__os.write(text.replace(<span class="py-string">'\n'</span>, <span class="py-string">'\n'</span>+indent))</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#start_entity">start_entity</a>(self, __type, **__params):</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Write the start of an entity, ending with a newline&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">      param_text = <span class="py-string">&quot;&quot;</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">      <span class="py-keyword">if</span> __params: param_text = <span class="py-string">&quot; &quot;</span> + string.join(map(<span class="py-keyword">lambda</span> p:<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]), __params.items()))</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      self.write(<span class="py-string">&quot;&lt;&quot;</span> + __type + param_text + <span class="py-string">&quot;&gt;&quot;</span>)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">      self.__indent = self.__indent + 2</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">      self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#end_entity">end_entity</a>(self, type):</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Write the end of an entity, starting with a newline&quot;&quot;&quot;</span></span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">      self.__indent = self.__indent - 2</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">      self.write(<span class="py-string">&quot;\n&lt;/&quot;</span> + type + <span class="py-string">&quot;&gt;&quot;</span>)</span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#write_entity">write_entity</a>(self, __type, __body, **__params):</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Write a single entity on one line (though body may contain</span></span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line"><span class="py-string">      newlines)&quot;&quot;&quot;</span></span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      param_text = <span class="py-string">&quot;&quot;</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">      <span class="py-keyword">if</span> __params: param_text = <span class="py-string">&quot; &quot;</span> + string.join(map(<span class="py-keyword">lambda</span> p:<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]), __params.items()))</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">      self.write(<span class="py-string">&quot;&lt;&quot;</span> + __type + param_text + <span class="py-string">&quot;&gt;&quot;</span>)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">      self.__indent = self.__indent + 2</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">      self.write(__body)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">      self.__indent = self.__indent - 2</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      self.write(<span class="py-string">&quot;&lt;/&quot;</span> + __type + <span class="py-string">&quot;&gt;&quot;</span>)</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#entity">entity</a>(self, __type, __body, **__params):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Return but do not write the text for an entity on one line&quot;&quot;&quot;</span></span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">      param_text = <span class="py-string">&quot;&quot;</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">      <span class="py-keyword">if</span> __params: param_text = <span class="py-string">&quot; &quot;</span> + string.join(map(<span class="py-keyword">lambda</span> p:<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]), __params.items()))</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">&quot;&lt;%s%s&gt;%s&lt;/%s&gt;&quot;</span>%(__type, param_text, __body, __type)</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#reference">reference</a>(self, ref, label):</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">      <span class="py-string">&quot;&quot;&quot;reference takes two strings, a reference (used to look up the symbol and generated the reference),</span></span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line"><span class="py-string">      and the label (used to actually write it)&quot;&quot;&quot;</span></span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">      location = self.__toc.lookup(ref)</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">      <span class="py-keyword">if</span> location != <span class="py-string">&quot;&quot;</span>: <span class="py-keyword">return</span> href(<span class="py-string">&quot;#&quot;</span> + location, label)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">      <span class="py-keyword">else</span>: <span class="py-keyword">return</span> span(<span class="py-string">&quot;type&quot;</span>, str(label))</span>
<a id="line99"></a><span class="lineno"> 99</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#label">label</a>(self, ref):</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">      location = self.__toc.lookup(str(ref))</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">      ref = str(self.scope().prune(ref))</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">      <span class="py-keyword">if</span> location != <span class="py-string">&quot;&quot;</span>: <span class="py-keyword">return</span> name(<span class="py-string">&quot;\&quot;&quot;</span> + location + <span class="py-string">&quot;\&quot;&quot;</span>, ref)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">      <span class="py-keyword">else</span>: <span class="py-keyword">return</span> ref</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#type_label">type_label</a>(self): <span class="py-keyword">return</span> self.__type_label</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">   <span class="py-comment">#################### Type Visitor ##########################################</span></span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">      self.__type_label = str(type.name)</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type):</span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">      self.__type_label = str(self.scope().prune(type.name))</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">      self.__type_label = str(self.scope().prune(type.name))</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line124"></a><span class="lineno">124</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">      type.alias.accept(self)</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">      self.__type_ref = <span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_ref + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">      self.__type_label = <span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_label + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line132"></a><span class="lineno">132</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">      type.template.accept(self)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">      type_label = self.__type_label + <span class="py-string">&quot;&amp;lt;&quot;</span></span>
<a id="line135"></a><span class="lineno">135</span><span class="line">      parameters_label = []</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">         p.accept(self)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">         parameters_label.append(self.__type_label)</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">      self.__type_label = type_label + <span class="py-string">', '</span>.join(parameters_label) + <span class="py-string">'&amp;gt;'</span></span>
<a id="line140"></a><span class="lineno">140</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#format_type">format_type</a>(self, type):</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">      type.accept(self)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">      <span class="py-keyword">return</span> self.__type_label</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">      <span class="py-comment"># TODO: this needs to be implemented</span></span>
<a id="line149"></a><span class="lineno">149</span><span class="line">      self.__type_ref = <span class="py-string">'function_type'</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line">      self.__type_label = <span class="py-string">'function_type'</span></span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#process_doc">process_doc</a>(self, doc):</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">      text = doc.replace(<span class="py-string">'\n\n'</span>, <span class="py-string">'&lt;/para&gt;&lt;para&gt;'</span>)</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">      self.write(self.entity(<span class="py-string">&quot;para&quot;</span>, text)+<span class="py-string">'\n'</span>)</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">   <span class="py-comment">#################### ASG Visitor ###########################################</span></span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_declarator">visit_declarator</a>(self, node):</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">      self.__declarator = node.name</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> node.sizes:</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">         self.__declarator[-1] = self.__declarator[-1] + <span class="py-string">'[%d]'</span>%i</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_typedef">visit_typedef</a>(self, typedef):</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">      self.start_entity(<span class="py-string">&quot;typedef&quot;</span>, name=str(self.scope().prune(typedef.name)))</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">      self.write_entity(<span class="py-string">&quot;type&quot;</span>, self.format_type(typedef.alias))</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">      self.end_entity(<span class="py-string">&quot;typedef&quot;</span>)</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_variable">visit_variable</a>(self, variable):</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">      self.start_entity(<span class="py-string">&quot;fieldsynopsis&quot;</span>)</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">      variable.vtype.accept(self)</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">      self.entity(<span class="py-string">&quot;type&quot;</span>, self.type_label())</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">      self.entity(<span class="py-string">&quot;varname&quot;</span>, variable.name[-1])</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">      self.end_entity(<span class="py-string">&quot;fieldsynopsis&quot;</span>)</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_const">visit_const</a>(self, const):</span>
<a id="line179"></a><span class="lineno">179</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">      <span class="py-keyword">print</span> <span class="py-string">&quot;sorry, &lt;const&gt; not implemented&quot;</span></span>
<a id="line181"></a><span class="lineno">181</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_module">visit_module</a>(self, module):</span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">      self.start_entity(<span class="py-string">&quot;namespace&quot;</span>, name=str(self.scope().prune(module.name)))</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">      self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">      self.process_doc(module.annotations.get(<span class="py-string">'doc'</span>, <span class="py-string">''</span>))</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">      self.push_scope(module.name)</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">      <span class="py-keyword">for</span> declaration <span class="py-keyword">in</span> module.declarations: declaration.accept(self)</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">      self.pop_scope()</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">      self.end_entity(<span class="py-string">&quot;namespace&quot;</span>)</span>
<a id="line191"></a><span class="lineno">191</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line193"></a><span class="lineno">193</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">      self.start_entity(<span class="py-string">&quot;class&quot;</span>, name=str(self.scope().prune(class_.name)))</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">      <span class="py-comment"># class_.type</span></span>
<a id="line196"></a><span class="lineno">196</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> class_.parents:</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">         p.accept(self)</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">      self.push_scope(class_.name)</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">      <span class="py-keyword">if</span> class_.annotations.has_key(<span class="py-string">'doc'</span>):</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">         self.start_entity(<span class="py-string">&quot;purpose&quot;</span>)</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">         self.process_doc(class_.annotations.get[<span class="py-string">'doc'</span>])</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">         self.end_entity(<span class="py-string">&quot;purpose&quot;</span>)</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> class_.declarations:</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">         d.accept(self)</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">      self.pop_scope()</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">      self.end_entity(<span class="py-string">&quot;class&quot;</span>)</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_inheritance">visit_inheritance</a>(self, inheritance):</span>
<a id="line209"></a><span class="lineno">209</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">      <span class="py-keyword">if</span> len(inheritance.attributes()):</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">         self.start_entity(<span class="py-string">&quot;inherit&quot;</span>, access=inheritance.attributes()[0])</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">         self.start_entity(<span class="py-string">&quot;inherit&quot;</span>)</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">      self.write_entity(<span class="py-string">&quot;classname&quot;</span>, self.format_type(inheritance.parent()))</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">      self.end_entity(<span class="py-string">&quot;inherit&quot;</span>)</span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line218"></a><span class="lineno">218</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">      self.start_entity(<span class="py-string">&quot;parameter&quot;</span>, name=parameter.name)</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">      self.write_entity(<span class="py-string">&quot;param_type&quot;</span>, self.format_type(parameter.type))</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">      <span class="py-comment">#map(lambda m, this=self: this.write_entity(&quot;modifier&quot;, m), parameter.premodifier)</span></span>
<a id="line222"></a><span class="lineno">222</span><span class="line">      <span class="py-comment">#map(lambda m, this=self: this.write_entity(&quot;modifier&quot;, m), parameter.postmodifier)</span></span>
<a id="line223"></a><span class="lineno">223</span><span class="line">      self.end_entity(<span class="py-string">&quot;parameter&quot;</span>)</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">      self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_function">visit_function</a>(self, function):</span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span><span class="line">      self.start_entity(<span class="py-string">&quot;function&quot;</span>, name=str(self.scope().prune(function.real_name)))</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">      self.do_function(function)</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">      self.end_entity(<span class="py-string">&quot;function&quot;</span>)</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">      self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line232"></a><span class="lineno">232</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_operation">visit_operation</a>(self, operation):</span>
<a id="line234"></a><span class="lineno">234</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">      name = operation.name</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">      tag = None</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">      <span class="py-keyword">if</span> len(name) &gt; 1:</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">         <span class="py-keyword">if</span> name[-1] == name[-2]:</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">            tag = <span class="py-string">&quot;constructor&quot;</span></span>
<a id="line240"></a><span class="lineno">240</span><span class="line">            self.start_entity(tag)</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">         <span class="py-keyword">elif</span> name[-1] == <span class="py-string">&quot;~&quot;</span>+name[-2]:</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">            tag = <span class="py-string">&quot;destructor&quot;</span></span>
<a id="line243"></a><span class="lineno">243</span><span class="line">            self.start_entity(tag)</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">      <span class="py-keyword">if</span> tag <span class="py-keyword">is</span> None:</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">         tag = <span class="py-string">&quot;method&quot;</span></span>
<a id="line246"></a><span class="lineno">246</span><span class="line">         self.start_entity(tag, name=str(self.scope().prune(operation.real_name)))</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">      self.do_function(operation)</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">      self.end_entity(tag)</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">      self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line250"></a><span class="lineno">250</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#do_function">do_function</a>(self, func):</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Stuff common to functions and methods, contructors, destructors&quot;&quot;&quot;</span></span>
<a id="line253"></a><span class="lineno">253</span>
<a id="line254"></a><span class="lineno">254</span><span class="line">      <span class="py-keyword">for</span> parameter <span class="py-keyword">in</span> func.parameters: parameter.accept(self)</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">      <span class="py-keyword">if</span> func.return_type:</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">         self.write_entity(<span class="py-string">&quot;type&quot;</span>, self.format_type(func.return_type))</span>
<a id="line257"></a><span class="lineno">257</span><span class="line">         self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">      <span class="py-keyword">if</span> func.annotations.has_key(<span class="py-string">'doc'</span>):</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">         self.start_entity(<span class="py-string">&quot;purpose&quot;</span>)</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">         self.process_doc(func.annotations[<span class="py-string">'doc'</span>])</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">         self.end_entity(<span class="py-string">&quot;purpose&quot;</span>)</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">         self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line263"></a><span class="lineno">263</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">      <span class="py-keyword">if</span> func.exceptions:</span>
<a id="line265"></a><span class="lineno">265</span><span class="line">         self.start_entity(<span class="py-string">&quot;throws&quot;</span>)</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">         <span class="py-keyword">for</span> ex <span class="py-keyword">in</span> func.exceptions:</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">            self.write_entity(<span class="py-string">&quot;simpara&quot;</span>, ex)</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">         self.end_entity(<span class="py-string">&quot;throws&quot;</span>)</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">         self.write(<span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_enumerator">visit_enumerator</a>(self, enumerator):</span>
<a id="line272"></a><span class="lineno">272</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">      <span class="py-keyword">print</span> <span class="py-string">&quot;sorry, &lt;enumerator&gt; not implemented&quot;</span></span>
<a id="line274"></a><span class="lineno">274</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/BoostBook/Formatter.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line276"></a><span class="lineno">276</span>
<a id="line277"></a><span class="lineno">277</span><span class="line">      <span class="py-keyword">print</span> <span class="py-string">&quot;sorry, &lt;enum&gt; not implemented&quot;</span></span>
<a id="line278"></a><span class="lineno">278</span>
<a id="line279"></a><span class="lineno">279</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
